xine-lib: xine-lib-1.2.13/src/demuxers/demux_idcin.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions
demux_idcin.c File Reference
`#include <stdio.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/compat.h>`
`#include <xine/demux.h>`
`#include "bswap.h"`
`#include "group_games.h"`

## Data Structures
struct | demux_idcin_t

## Macros
#define | LOG_MODULE "demux_idcin"
#define | LOG_VERBOSE
#define | IDCIN_HEADER_SIZE 20
#define | HUFFMAN_TABLE_SIZE 65536
#define | IDCIN_FRAME_PTS_INC (90000 / 14)
#define | PALETTE_SIZE 256

## Functions
static int | demux_idcin_send_chunk (demux_plugin_t *this_gen)
static int | open_idcin_file (demux_idcin_t *this)
static void | demux_idcin_send_headers (demux_plugin_t *this_gen)
static int | demux_idcin_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static int | demux_idcin_get_status (demux_plugin_t *this_gen)
static int | demux_idcin_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_idcin_get_capabilities (demux_plugin_t *this_gen)
static int | demux_idcin_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
void * | demux_idcin_init_plugin (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ HUFFMAN_TABLE_SIZE

#define HUFFMAN_TABLE_SIZE 65536

Referenced by demux_idcin_seek(), demux_idcin_send_chunk(), demux_idcin_send_headers(), and open_idcin_file().

## ◆ IDCIN_FRAME_PTS_INC

#define IDCIN_FRAME_PTS_INC (90000 / 14)

Referenced by demux_idcin_send_chunk(), and demux_idcin_send_headers().

## ◆ IDCIN_HEADER_SIZE

#define IDCIN_HEADER_SIZE 20

Referenced by demux_idcin_seek(), demux_idcin_send_chunk(), and open_idcin_file().

## ◆ LOG_MODULE

#define LOG_MODULE "demux_idcin"

## ◆ LOG_VERBOSE

#define LOG_VERBOSE

## ◆ PALETTE_SIZE

#define PALETTE_SIZE 256

Referenced by demux_idcin_send_chunk().

## Function Documentation

## ◆ demux_idcin_get_capabilities()

static uint32_t demux_idcin_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_idcin_get_optional_data()

static int demux_idcin_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_idcin_get_status()

static int demux_idcin_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_idcin_get_stream_length()

static int demux_idcin_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_idcin_init_plugin()

void * demux_idcin_init_plugin | ( | xine_t * | xine,
|  | const void * | data )

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ demux_idcin_seek()

static int demux_idcin_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References _x_demux_control_newpts(), DEMUX_OK, HUFFMAN_TABLE_SIZE, IDCIN_HEADER_SIZE, and input().

Referenced by open_plugin().

## ◆ demux_idcin_send_chunk()

static int demux_idcin_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References _X_LE_32, palette_entry_s::b, BUF_AUDIO_LPCM_LE, BUF_FLAG_FRAME_END, BUF_FLAG_HEADER, BUF_FLAG_KEYFRAME, BUF_FLAG_SPECIAL, BUF_SPECIAL_PALETTE, BUF_VIDEO_IDCIN, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, buf_element_s::decoder_info_ptr, DEMUX_FINISHED, buf_element_s::extra_info, buf_element_s::free_buffer, palette_entry_s::g, HUFFMAN_TABLE_SIZE, IDCIN_FRAME_PTS_INC, IDCIN_HEADER_SIZE, input(), extra_info_s::input_normpos, extra_info_s::input_time, le2me_32, lprintf, buf_element_s::max_size, NULL, PALETTE_SIZE, buf_element_s::pts, palette_entry_s::r, buf_element_s::size, and buf_element_s::type.

Referenced by open_plugin().

## ◆ demux_idcin_send_headers()

static void demux_idcin_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), BUF_AUDIO_LPCM_LE, BUF_FLAG_FRAME_END, BUF_FLAG_FRAMERATE, BUF_FLAG_HEADER, BUF_FLAG_STDHEADER, BUF_VIDEO_IDCIN, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, DEMUX_OK, HUFFMAN_TABLE_SIZE, IDCIN_FRAME_PTS_INC, lprintf, buf_element_s::max_size, buf_element_s::size, and buf_element_s::type.

Referenced by open_plugin().

## ◆ open_idcin_file()

static int open_idcin_file | ( | demux_idcin_t * | this | ) |
| static

References _x_demux_read_header(), _X_LE_32, _x_stream_info_set(), xine_bmiheader::biHeight, xine_bmiheader::biWidth, HUFFMAN_TABLE_SIZE, IDCIN_HEADER_SIZE, input(), lprintf, XINE_STREAM_INFO_AUDIO_BITS, XINE_STREAM_INFO_AUDIO_CHANNELS, XINE_STREAM_INFO_AUDIO_SAMPLERATE, XINE_STREAM_INFO_HAS_AUDIO, XINE_STREAM_INFO_HAS_VIDEO, XINE_STREAM_INFO_VIDEO_HEIGHT, and XINE_STREAM_INFO_VIDEO_WIDTH.

Referenced by open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References xine_stream_s::content_detection_method, default_demux_plugin_dispose, DEMUX_FINISHED, demux_idcin_get_capabilities(), demux_idcin_get_optional_data(), demux_idcin_get_status(), demux_idcin_get_stream_length(), demux_idcin_seek(), demux_idcin_send_chunk(), demux_idcin_send_headers(), input(), METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, open_idcin_file(), and input_plugin_s::seek.

Referenced by demux_idcin_init_plugin().